# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.datasource import Datasource  # noqa: F401,E501
from swagger_server.models.datasource_type import DatasourceType  # noqa: F401,E501
from swagger_server.models.ransim_metrics import RansimMetrics  # noqa: F401,E501
from swagger_server import util


class RansimDatasource(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, datasource_type: DatasourceType=None, id: str=None, remote_output_file_path: str=None, remote_input_files_path: List[str]=None, metrics: List[RansimMetrics]=None, topic_name: str=None):  # noqa: E501
        """RansimDatasource - a model defined in Swagger

        :param datasource_type: The datasource_type of this RansimDatasource.  # noqa: E501
        :type datasource_type: DatasourceType
        :param id: The id of this RansimDatasource.  # noqa: E501
        :type id: str
        :param remote_output_file_path: The remote_output_file_path of this RansimDatasource.  # noqa: E501
        :type remote_output_file_path: str
        :param remote_input_files_path: The remote_input_files_path of this RansimDatasource.  # noqa: E501
        :type remote_input_files_path: List[str]
        :param metrics: The metrics of this RansimDatasource.  # noqa: E501
        :type metrics: List[RansimMetrics]
        :param topic_name: The topic_name of this RansimDatasource.  # noqa: E501
        :type topic_name: str
        """
        self.swagger_types = {
            'datasource_type': DatasourceType,
            'id': str,
            'remote_output_file_path': str,
            'remote_input_files_path': List[str],
            'metrics': List[RansimMetrics],
            'topic_name': str
        }

        self.attribute_map = {
            'datasource_type': 'datasource-type',
            'id': 'id',
            'remote_output_file_path': 'remote-output-file-path',
            'remote_input_files_path': 'remote-input-files-path',
            'metrics': 'metrics',
            'topic_name': 'topic-name'
        }
        self._datasource_type = datasource_type
        self._id = id
        self._remote_output_file_path = remote_output_file_path
        self._remote_input_files_path = remote_input_files_path
        self._metrics = metrics
        self._topic_name = topic_name

    @classmethod
    def from_dict(cls, dikt) -> 'RansimDatasource':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ransim-datasource of this RansimDatasource.  # noqa: E501
        :rtype: RansimDatasource
        """
        return util.deserialize_model(dikt, cls)

    @property
    def datasource_type(self) -> DatasourceType:
        """Gets the datasource_type of this RansimDatasource.


        :return: The datasource_type of this RansimDatasource.
        :rtype: DatasourceType
        """
        return self._datasource_type

    @datasource_type.setter
    def datasource_type(self, datasource_type: DatasourceType):
        """Sets the datasource_type of this RansimDatasource.


        :param datasource_type: The datasource_type of this RansimDatasource.
        :type datasource_type: DatasourceType
        """

        self._datasource_type = datasource_type

    @property
    def id(self) -> str:
        """Gets the id of this RansimDatasource.

        Identifier of the RANSim datasource  # noqa: E501

        :return: The id of this RansimDatasource.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this RansimDatasource.

        Identifier of the RANSim datasource  # noqa: E501

        :param id: The id of this RansimDatasource.
        :type id: str
        """

        self._id = id

    @property
    def remote_output_file_path(self) -> str:
        """Gets the remote_output_file_path of this RansimDatasource.

        Path of the output file on the RAN simulator machine  # noqa: E501

        :return: The remote_output_file_path of this RansimDatasource.
        :rtype: str
        """
        return self._remote_output_file_path

    @remote_output_file_path.setter
    def remote_output_file_path(self, remote_output_file_path: str):
        """Sets the remote_output_file_path of this RansimDatasource.

        Path of the output file on the RAN simulator machine  # noqa: E501

        :param remote_output_file_path: The remote_output_file_path of this RansimDatasource.
        :type remote_output_file_path: str
        """
        if remote_output_file_path is None:
            raise ValueError("Invalid value for `remote_output_file_path`, must not be `None`")  # noqa: E501

        self._remote_output_file_path = remote_output_file_path

    @property
    def remote_input_files_path(self) -> List[str]:
        """Gets the remote_input_files_path of this RansimDatasource.

        List of the paths of the input files on the RAN simulator machine  # noqa: E501

        :return: The remote_input_files_path of this RansimDatasource.
        :rtype: List[str]
        """
        return self._remote_input_files_path

    @remote_input_files_path.setter
    def remote_input_files_path(self, remote_input_files_path: List[str]):
        """Sets the remote_input_files_path of this RansimDatasource.

        List of the paths of the input files on the RAN simulator machine  # noqa: E501

        :param remote_input_files_path: The remote_input_files_path of this RansimDatasource.
        :type remote_input_files_path: List[str]
        """
        if remote_input_files_path is None:
            raise ValueError("Invalid value for `remote_input_files_path`, must not be `None`")  # noqa: E501

        self._remote_input_files_path = remote_input_files_path

    @property
    def metrics(self) -> List[RansimMetrics]:
        """Gets the metrics of this RansimDatasource.


        :return: The metrics of this RansimDatasource.
        :rtype: List[RansimMetrics]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics: List[RansimMetrics]):
        """Sets the metrics of this RansimDatasource.


        :param metrics: The metrics of this RansimDatasource.
        :type metrics: List[RansimMetrics]
        """

        self._metrics = metrics

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this RansimDatasource.


        :return: The topic_name of this RansimDatasource.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this RansimDatasource.


        :param topic_name: The topic_name of this RansimDatasource.
        :type topic_name: str
        """

        self._topic_name = topic_name
